"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var effects = require("redux-saga/effects");
var fetch_1 = require("./fetch");
var Immutable = require("seamless-immutable");
var url_1 = require("./url");
var call = effects.call, put = effects.put, select = effects.select;
var init = function (config, options) {
    var initialStates = config.map(function (o) {
        var _a;
        return _a = {},
            _a[o.name] = {
                result: o.initialResult,
                loading: false,
                error: '',
            },
            _a;
    });
    var iState = Object.assign.apply(Object, [{}].concat(initialStates));
    var initialState = Immutable.from(iState);
    var reducer = function (state, action) {
        if (state === void 0) { state = initialState; }
        var _a, _b, _c;
        if (action.type === 'RESET_STATE') {
            return initialState;
        }
        if (!action.payload) {
            return state;
        }
        var _d = action.payload, payload = _d.payload, name = _d.name;
        var opt = config.find(function (o) {
            return o.name === name;
        });
        if (!opt) {
            return state;
        }
        var existingState = state[opt.name];
        switch (action.type) {
            case opt.name + "__LOADING": {
                var newState = Object.assign({}, existingState, { loading: payload });
                return __assign({}, state, (_a = {}, _a[opt.name] = newState, _a));
            }
            case opt.name + "__ERROR": {
                var newState = Object.assign({}, existingState, { error: payload });
                return __assign({}, state, (_b = {}, _b[opt.name] = newState, _b));
            }
            case opt.name + "__SUCCESS": {
                var newState = Object.assign({}, existingState, { result: payload });
                return __assign({}, state, (_c = {}, _c[opt.name] = newState, _c));
            }
            default: {
                return state;
            }
        }
    };
    var sagas = config.map(function (o) {
        function saga(_a) {
            var name, state, getReqHeadersDefault, getReqHeadersHook, reqHeaders, dataReqOptions, source, reqOptions, successHook, errorHook, _onDispatch, result, processedResult, error_1, errorMsg;
            var type = _a.type, payload = _a.payload, api = _a.api, onSuccess = _a.onSuccess, onError = _a.onError, getReqHeaders = _a.getReqHeaders, onDispatch = _a.onDispatch;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (!o) {
                            return [2 /*return*/];
                        }
                        name = o.name;
                        return [4 /*yield*/, select()];
                    case 1:
                        state = _b.sent();
                        getReqHeadersDefault = options.getReqHeadersDefault || (function () { return ({}); });
                        getReqHeadersHook = getReqHeaders || getReqHeadersDefault;
                        reqHeaders = getReqHeadersHook(state, payload);
                        return [4 /*yield*/, put({ type: name + "__LOADING", payload: { name: name, payload: true } })];
                    case 2:
                        _b.sent();
                        return [4 /*yield*/, put({ type: name + "__ERROR", payload: { name: name, payload: '', } })];
                    case 3:
                        _b.sent();
                        dataReqOptions = o.method !== 'GET' ? { data: payload } : {};
                        source = fetch_1.CancelToken.source();
                        reqOptions = __assign({ method: o.method, headers: reqHeaders, cancelToken: source.token }, dataReqOptions);
                        successHook = onSuccess || o.onSuccess;
                        errorHook = onError || o.onError;
                        _onDispatch = onDispatch || o.onDispatch;
                        _b.label = 4;
                    case 4:
                        _b.trys.push([4, 7, , 9]);
                        if (_onDispatch) {
                            _onDispatch(source.cancel, payload);
                        }
                        return [4 /*yield*/, call(fetch_1.fetchData, api, reqOptions)];
                    case 5:
                        result = _b.sent();
                        processedResult = o.processResult ? o.processResult(result) : result;
                        return [4 /*yield*/, put({ type: name + "__SUCCESS", payload: { name: name, payload: processedResult } })];
                    case 6:
                        _b.sent();
                        if (successHook) {
                            successHook(result, payload);
                        }
                        return [3 /*break*/, 9];
                    case 7:
                        error_1 = _b.sent();
                        errorMsg = typeof error_1 === 'string' ? error_1 : error_1.message;
                        return [4 /*yield*/, put({ type: name + "__ERROR", payload: { name: name, payload: errorMsg, } })];
                    case 8:
                        _b.sent();
                        if (errorHook) {
                            errorHook(error_1, payload);
                        }
                        return [3 /*break*/, 9];
                    case 9: return [4 /*yield*/, put({ type: name + "__LOADING", payload: { name: name, payload: false } })];
                    case 10:
                        _b.sent();
                        return [2 /*return*/];
                }
            });
        }
        return effects[o.mode || 'takeLatest'](o.name + "__DISPATCH", saga);
    });
    var findApiConfigFromName = function (name) {
        var opt = config.find(function (o) {
            return o.name === name;
        });
        if (!opt) {
            throw new Error(name + " is not registered in redux-api-saga config");
        }
        return opt;
    };
    var actionFn = function (_a) {
        var name = _a.name, payload = _a.payload, query = _a.query, params = _a.params, onSuccess = _a.onSuccess, onError = _a.onError, onDispatch = _a.onDispatch;
        try {
            var opt = findApiConfigFromName(name);
            var urlParser = options.urlParser || url_1.getUrl;
            var api = urlParser(opt.path, params, query);
            return {
                type: opt.name + "__DISPATCH",
                api: api,
                payload: payload,
                onSuccess: onSuccess,
                onError: onError,
                onDispatch: onDispatch,
            };
        }
        catch (err) {
            return { type: 'ERROR_IN_PARAMS' };
        }
    };
    return { reducer: reducer, sagas: sagas, action: actionFn, initialState: initialState };
};
exports.default = init;
